/*******************************************************************************
 * Copyright (c) 2008 Jason Kusnier & Tim Hollosy. All rights reserved.
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License v1.0 and Eclipse Distribution License v. 1.0
 * which accompanies this distribution.
 * The Eclipse Public License is available at http://www.eclipse.org/legal/epl-v10.html
 * and the Eclipse Distribution License is available at
 * http://www.eclipse.org/org/documents/edl-v10.php.
 *
 * Contributors:
 *     Jason Kusnier, Tim Hollosy, and Others
 ******************************************************************************/
package edu.its.emf;

import java.util.HashMap;
import java.util.Map;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;

import org.eclipse.persistence.config.PersistenceUnitProperties;
import org.eclipse.persistence.jpa.PersistenceProvider;



/**
*
* Creates the connection to the Derby Comics database.
*/
public abstract class ComicsEntityManagerFactory {

	private static EntityManagerFactory emf = null;
	private static Map<String, Object> properties = new HashMap<String, Object>();


	private static void init() {
		properties.put(PersistenceUnitProperties.TARGET_DATABASE, "Derby");
		properties.put(PersistenceUnitProperties.JDBC_DRIVER,"org.apache.derby.jdbc.ClientDriver");
		properties.put(PersistenceUnitProperties.JDBC_URL,"jdbc:derby://localhost:1527/sample;create=true");
		properties.put(PersistenceUnitProperties.JDBC_USER, "app");
		properties.put(PersistenceUnitProperties.JDBC_PASSWORD, "app");
		properties.put(PersistenceUnitProperties.JDBC_READ_CONNECTIONS_MIN, "1");
		properties.put(PersistenceUnitProperties.JDBC_WRITE_CONNECTIONS_MIN,"1");
		properties.put(PersistenceUnitProperties.BATCH_WRITING, "JDBC");
		properties.put(PersistenceUnitProperties.CLASSLOADER, ComicsEntityManagerFactory.class.getClassLoader());
		properties.put("eclipselink.logging.level", "FINE");
		properties.put("eclipselink.logging.timestamp", "false");
		properties.put("eclipselink.logging.session", "false");
		properties.put("eclipselink.logging.thread", "false");

		emf = new PersistenceProvider().createEntityManagerFactory("comics",
				properties);

	}

	/**
	 * Creates a new ComicsEntityManager object.
	 *
	 * @return the entity manager
	 */
	public static EntityManager createEntityManager() {
		if (emf == null)
			init();

		return emf.createEntityManager();
	}
}
