package edu.its.service;

import java.util.Collection;

import javax.persistence.EntityManager;
import javax.persistence.Query;

import edu.its.bean.User;

public class UserService {
	protected EntityManager em;
	public UserService(EntityManager em) {
        this.em = em;
    }

    public User createEmployee(String username, String password, String status) {
        User emp = new User();
        emp.setUsername(username);
        emp.setPassword(password);
        emp.setStatus(status);
        em.persist(emp);
        return emp;
    }

    public void removeUser(String username) {
        User emp = findUser(username);
        if (emp != null) {
            em.remove(emp);
        }
    }

    public User findUser(String username) {
        return em.find(User.class, username);
    }

    public Collection<User> findAllUsers() {
        Query query = em.createQuery("SELECT e FROM User e");
        return (Collection<User>) query.getResultList();
    }
}
